<?php
/*
Plugin Name: AskApache Password Protect
Plugin URI: http://www.askapache.com/wordpress/htaccess-password-protect.html
Description: Adds Password Protection to your wp-admin directory... <a href="http://www.askapache.com/wordpress/htaccess-password-protect.html">Plugin Home</a>
Author: AskApache
Version: 1.3
Author URI: http://www.askapache.com
Copyright (c) 2007 AskApache (http://www.askapache.com)

*/


function aa_pass_protect_options_setup() {
    add_options_page('AskApache Password Protect', 'AskApache Password Protect', 10, basename(__FILE__), 'aa_pass_protect_page');   
}




function aa_pass_protect_page() {
    global $aa_static_ip,$is_apache,$aa_home,$aa_version,$aa_htpasswd_f,$aa_wpadmin,$aa_htaccess_f,$aa_htpasswd_rules,$aa_htaccess_rules,$AA_PROTECTED,$aa_user,$aa_pass,$aa_pass2,$aa_wmessage;
    
    
    if(!isset($_SERVER['REMOTE_USER']) && !isset($_SERVER['REDIRECT_REMOTE_USER']))
    $AA_PROTECTED=0;
    else
    $AA_PROTECTED=1;
    
	$aa_passed=1;

    
    $aa_htpasswd_rules = array();
    $aa_htaccess_rules = array();
    
	
	        if ( get_option("aa_home") )
        {
            $aa_user  = get_option('aa_user');
			$aa_static_ip	= get_option('aa_static_ip');
            $aa_htpasswd_f = get_option('aa_htpasswd_f');
            $aa_htaccess_f = get_option('aa_htaccess_f');
            $aa_version = get_option('aa_version');
            $aa_home  = get_option('aa_home');
            $aa_wpadmin = get_option('aa_wpadmin');
        }
        else
        {

            $aa_version ='1.1';
       		$aa_static_ip	= 'No';
			$aa_home  = get_home_path();
            $aa_wpadmin = $aa_home.'wp-admin/';
            $aa_htpasswd_f = $aa_home.'.htpasswd';
            $aa_htaccess_f = $aa_wpadmin . '.htaccess';
			
			if(!file_exists($aa_htpasswd_f) && is_writable($aa_home) && is_writable($aa_htpasswd_f) )touch($aa_htpasswd_f);
    		if(!file_exists($aa_htaccess_f) && is_writable($aa_wpadmin) && is_writable($aa_htaccess_f) )touch($aa_htaccess_f);

            
            update_option('aa_version',$aa_version);
        	update_option('aa_static_ip',$aa_static_ip);
            update_option('aa_home',$aa_home);
            update_option('aa_wpadmin',$aa_wpadmin);
            update_option('aa_htpasswd_f',$aa_htpasswd_f);
            update_option('aa_htaccess_f',$aa_htaccess_f);
        }

	
	
    
    if (isset($_POST['uname']))
    {
        if ( isset($_POST['upass']) ) $aa_pass = stripslashes($_POST['upass']);
		else  
		{
		   $aa_wmessage .= "<h4>You must enter the password</h4>\n";
            $aa_passed=0;

		}
        if ( isset($_POST['upass2']) ) $aa_pass2 = stripslashes($_POST['upass2']);
		else  
		{
		   $aa_wmessage .= "<h4>You must enter the password</h4>\n";
            $aa_passed=0;

		}

        if ( isset($_POST['uname']) ) $aa_user = stripslashes($_POST['uname']);
		else  
		{
		   $aa_wmessage .= "<h4>You must enter the username</h4>\n";
            $aa_passed=0;

		}

        
        if ( $aa_user === ''){
            $aa_wmessage .= "<h4>You must enter the username</h4>\n";
            $aa_passed=0;
        }
        if ( $aa_pass === ''){
            $aa_wmessage .= "<h4>You must enter the password</h4>\n";
            $aa_passed=0;
        }
        if ( $aa_pass !== $aa_pass2 ){
            $aa_wmessage .= "<h4>You must enter the same password twice to confirm</h4>\n";
            $aa_passed=0;
        }
        
        
		update_option('aa_user',$aa_user);
        update_option('aa_static_ip',$aa_static_ip);
        update_option('aa_htpasswd_f',$_POST['aa_htpasswd_f']);
        update_option('aa_htaccess_f',$_POST['aa_htaccess_f']);
        update_option('aa_version',$_POST['aa_version']);
        update_option('aa_home',$_POST['aa_home']);
        update_option('aa_wpadmin',$_POST['aa_wpadmin']);
        
        $aa_user  = get_option('aa_user');
		$aa_static_ip	= get_option('aa_static_ip');
        $aa_htpasswd_f = get_option('aa_htpasswd_f');
        $aa_htaccess_f = get_option('aa_htaccess_f');
        $aa_version = get_option('aa_version');
        $aa_home  = get_option('aa_home');
        $aa_wpadmin = get_option('aa_wpadmin');
	        
        
        
         if($aa_passed)
		{
		        $aa_wmessage .= "<h4>SUCCESS - Options saved.</h4>\n";

      
        $encoded_string = crypt($aa_pass);
        $aa_htpasswd_rules[]=$aa_user.":".$encoded_string;
        
        
        
        $aa_htaccess_rules[]='AuthName "Authorization Required"';
        $aa_htaccess_rules[]="AuthUserFile $aa_htpasswd_f";
        $aa_htaccess_rules[]="AuthGroupFile /dev/null";
        $aa_htaccess_rules[]="AuthType Basic";
        $aa_htaccess_rules[]="Require user $aa_user";
        
        if(substr($_POST['submit'],0,2) =="IP"){
			$aa_static_ip = 'Yes';
			update_option('aa_static_ip',$aa_static_ip);
            $aa_htaccess_rules[]="order deny,allow";
            $aa_htaccess_rules[]="deny from all";
            $aa_htaccess_rules[]="allow from ".$_POST['uip'];
        } else 
		{
			$aa_static_ip = 'No';
			update_option('aa_static_ip',$aa_static_ip);
		}
		
        
        if ( aa_save_htaccess_rules() ) {
            //chmod($aa_htaccess_f, 0644);
            $aa_wmessage .=' <strong>SUCCESS:</strong> <code>.htaccess</code> rules successfully created.</p>'."\n";
        }
        else
        $aa_wmessage .='<p><strong>FAILURE:</strong> <code>.htaccess</code> rules failed to be created.</p>'."\n";
        
        
        
        if ( aa_save_htpasswd_rules() ) {
            //chmod($aa_htpasswd_f, 0640);
            $aa_wmessage .='<p><strong>SUCCESS:</strong> <code>.htpasswd</code> rules successfully created.</p>'."\n";
        }
        else
        $aa_wmessage .='<p><strong>FAILURE:</strong> <code>.htpasswd</code> rules failed to be created.</p>'."\n";
        }

    }
    else
    {
        
		$aa_wmessage ='<h3>Please enter in a username and password, and select the type of access to implement. </h3>'."\n";
                
    }
	
	
        
        passwordform();
}



function passwordform(){
    global $aa_static_ip,$is_apache,$aa_home,$aa_version,$aa_htpasswd_f,$aa_wpadmin,$aa_htaccess_f,$aa_htpasswd_rules,$aa_htaccess_rules,$AA_PROTECTED,$aa_user,$aa_wmessage;
    ?>
    <div class="wrap aa_messag" style="color:#BB000;">
	
    <?php echo $aa_wmessage;?>
	<p><a href="http://www.askapache.com/htaccess/apache-htaccess.html">htaccess guide</a></p>
	</div>
    <div class="wrap">
    <h2>AskApache Password Protect</h2>
    <form name="formamt" method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>">
    <fieldset class="options">
    <legend>User/Password Configuration</legend>
    <p><label>Username: <input size="50" type="text" name="uname" value="<?php echo $aa_user;?>" /></label></p>
    <p><label>IP Address: <input size="50" type="text" name="ipaddy" value="<?php echo $_SERVER['REMOTE_ADDR'];?>" /></label></p>
    <p><label>Password: <input size="50" type="password" name="upass" value="" /></label></p>
    <p><label>Password: <input size="50" type="password" name="upass2" value="" /></label></p>
    </fieldset>
    <fieldset class="options">
    <legend>File Configuration</legend>
    <p><label>.htpasswd location: <input type="text" size="80" name="aa_htpasswd_f" value="<?php echo $aa_htpasswd_f;?>" /></label></p>
    <p><label>.htaccess location: <input type="text" size="80" name="aa_htaccess_f" value="<?php echo $aa_htaccess_f;?>" /></label></p>
    <p><label>blog home path: <input type="text" size="80" name="aa_home" value="<?php echo $aa_home;?>" /></label></p>
    <p><label>wp-admin path: <input type="text" size="80" name="aa_wpadmin" value="<?php echo $aa_wpadmin;?>" /></label></p>
    </fieldset>
    <h4>Only use IP protection if you know what you are doing. Otherwise, use "Password protection only".</h4>
    <p class="submit">If you do not have fixed IP ==> <input type="submit" name="submmit" value="Password Protection Only (default)" /></p>
    <p class="submit"><input type="submit" name="submit" value="IP protection: <?php echo $_SERVER['REMOTE_ADDR'];?> + Password Protection" /></p>
    <input type="hidden" name="uip" value="<?php echo $_SERVER['REMOTE_ADDR'];?>" />
    <input type="hidden" name="aa_version" value="<?php echo $aa_version;?>" />
    </form>
    </div>
    
	    <?php
		$aa_home_p = '0755';
        $aa_htpasswd_p = '0640';
        $aa_wpadmin_p = '0755';
        $aa_htaccess_p = '0644';
        

        echo "<div class=\"wrap\">\n";
        echo "<h2>Information</h2>\n";
        if(got_mod_rewrite() && $is_apache)
        echo "<p>You have <code>Apache and mod_rewrite</code>!</p>\n";
        echo "<p><strong>username: </strong><code>$aa_user</code></p>\n";
		echo "<p><strong>IP Address: </strong><code>".$_SERVER['REMOTE_ADDR']."</code></p>\n";
		echo "<p><strong>Fixed IP Protection: </strong><code>".$aa_static_ip."</code></p>\n";
        echo "<p><strong>$aa_home_p home path: </strong><code>$aa_home</code></p>\n";
        echo "<p><strong>$aa_wpadmin_p wp-admin path: </strong><code>$aa_wpadmin</code></p>\n";
        echo "<p><strong>$aa_htpasswd_p htpasswd file: </strong><code>$aa_htpasswd_f</code></p>\n";
        echo "<p><strong>$aa_htaccess_p htaccess file: </strong><code>$aa_htaccess_f</code></p>\n";
        echo "</div>\n";

	?>

    <?php
}



function aa_save_htaccess_rules() {
    global $aa_static_ip,$is_apache,$aa_home,$aa_version,$aa_htpasswd_f,$aa_wpadmin,$aa_htaccess_f,$aa_htpasswd_rules,$aa_htaccess_rules,$AA_PROTECTED,$aa_user,$aa_pass,$aa_pass2,$aa_wmessage;
    
    if(!file_exists($aa_htaccess_f) && is_writable($aa_wpadmin) && is_writable($aa_htaccess_f) ) return false;
    else $aa_wmessage .= '<p>.htaccess file exists... writing...</p>';
    
    return insert_with_markers( $aa_htaccess_f, 'AskApache Password Protect', $aa_htaccess_rules );
    
}




function aa_save_htpasswd_rules() {
    global $aa_static_ip,$is_apache,$aa_home,$aa_version,$aa_htpasswd_f,$aa_wpadmin,$aa_htaccess_f,$aa_htpasswd_rules,$aa_htaccess_rules,$AA_PROTECTED,$aa_user,$aa_pass,$aa_pass2,$aa_wmessage;
    
    /* check if files exist, if not create them */
    if(!file_exists($aa_htpasswd_f) && is_writable($aa_home) && is_writable($aa_htpasswd_f) ) return false;
    else $aa_wmessage .= '<p>.htpasswd file exists... writing...</p>';
    
    return insert_with_markers( $aa_htpasswd_f, 'AskApache Password Protect', $aa_htpasswd_rules );
    
}




add_action('admin_menu', 'aa_pass_protect_options_setup');
?>